#include <stdio.h> // for putchar

#include "hexfile.hh"
#include "memory.hh"
#include "cpu.hh"

int main()
{
    LoadHexFile("test.hex");

    // Running loop.
    for(;; ++CycleCounter)
    {
        // Execute instruction
        ExecuteOpcode();

        // Update timer 0
        if(++TMR0_prescaler >= (OPTION.PSA ? 1 : (2 << OPTION.PreScale)))
        {
            TMR0_prescaler = 0;
            if(!(unsigned char)++TMR0)
            {
                //fprintf(stderr, "TMR0 wrap, T0IF set\n");
                INTCON.T0IF = true;
            }
            //fprintf(stderr, "TMR0 became %02X\n", TMR0);
        }

        // Update timer 2
        if(++TMR2_prescaler >= (1 << T2CON.PreScale))
        {
            TMR2_prescaler = 0;

            if(++TMR2 > PR2)
            {
                TMR2 =   0;
                CCPR1H = CCPR1L*4 + CCP1CON.lsb;
                //CCP1   = false;
            }
        }
        for(unsigned c=0; c<4; ++c)
        {
            bool CCP1 = (TMR2*4+c) < CCPR1H;
            putchar(CCP1 ? 0x40 : 0xC0);
            //putchar(CCPR1H >> 2);
        }
        //putchar(CCPR1H >> 2);

        /*for(unsigned c=0; c<4; ++c)
        putchar(CCPR1H);
        // putchar(CCP1CON.raw);
        */
    }
}
